From 2d3ed621c295461c6199e129631d62f928ae3075 Mon Sep 17 00:00:00 2001
From: rlarjsdn122 <rlarjsdn122@naver.com>
Date: Tue, 8 Oct 2019 16:27:35 +0900
Subject: [PATCH website] Change words in Korean translation

Signed-off-by: rlarjsdn122 <rlarjsdn122@naver.com>
---
 templates/ko/about.template              | 24 ++++++++++++------------
 templates/ko/global/xml/trans/global.xml |  4 ++--
 2 files changed, 14 insertions(+), 14 deletions(-)

diff --git a/templates/ko/about.template b/templates/ko/about.template
index aa0c9254..9b68e032 100644
--- a/templates/ko/about.template
+++ b/templates/ko/about.template
@@ -3,29 +3,29 @@
 <h1 class="title">와인에 관해</h1>
 
 <p>와인(원래 "와인은 대리 실행기가 아니다.(Wine Is Not an Emulator)"의 머릿글자 입니다.)은 리눅스, 맥, BSD와 같은 POSIX 기반 운영체제에서 
-윈도우용 응용 무른모를 실행시키는 호환성 레이어입니다.
+윈도우용 무른모를 실행시키는 호환성 층계입니다.
 가상전산기나 대리 실행기처럼 윈도우 내부 시스템을 베껴오는 것 대신
-와인은 윈도우 응용 무른모 프로그래밍 인터페이스를 POSIX 명령어로 곧바로 번역하여 
-성능과 메모리 문제를 해결해 다른 방식과는 차별화된 호환성을 제공합니다.</p>
+와인은 윈도우 무른모 프로그래밍 사이틀을 POSIX 명령어로 곧바로 번역하여 
+성능과 막기억장치 문제를 해결해 다른 방식과는 차별화된 호환성을 제공합니다.</p>
 
-<p>와인은 Bob Amstadt가 윈도우 3.1용 풀그림을 리눅스에서 작동시키기위해 1993년에 첫선을 보였습니다.
-아주 초창기에 와인 개발 책임은 이후에 줄곧 프로젝트를 관리하는 알렉산드르 줄리아드에게 넘어갔습니다.
-몇해가 지난 후, 윈도우 무른모 프로그래밍 인터페이스와 응용 무른모는 새로운 굳은모와 무른모의 이점을 얻고자 진화했고,
+<p>와인은 밥 암스테드가 윈도우 3.1용 풀그림을 리눅스에서 작동시키기 위해 1993년에 첫선을 보였습니다.
+아주 초창기에 와인 개발 책임은 이후에 줄곧 사업을 관리하는 알렉산드르 줄리아드에게 넘어갔습니다.
+수 해가 지난 후, 윈도우 무른모 프로그래밍 사이틀과 무른모는 새로운 굳은모와 무른모의 이점을 얻고자 진화했고,
 와인 또한 새 기능을 지원하는 동시에 새로운 운영체제에 이식되어 더 안정적이고 좋은 사용자 경험을 제공하게 됐습니다.
 </p>
 
-<p>본질적으로 이 야심찬 와인 프로젝트는 첫 안정판이 나오는 2008년까지 총 15년간 꾸준히 개발되었습니다.
+<p>본질적으로 이 야심찬 와인 사업은 첫 안정판이 나온 2008년까지 총 15년간 꾸준히 개발되었습니다.
 여러 안정판이 나운 후에도 와인은 오늘날에도 여전히 개발 중이고 아직 해야 할 작업이 많이 남았습니다.
-또한 <a href="https://wiki.winehq.org/UsageStatistics" title="와인 사용 현황">수백만여명</a>이 자신의 운영체제에서 윈도우용 무른모를 구동시키기 위해 와인을 사용하는 것으로 추정됩니다. </p>
+또한 <a href="https://wiki.winehq.org/UsageStatistics" title="와인 사용 현황">수백만여 명</a>이 자신의 운영체제에서 윈도우용 무른모를 구동시키기 위해 와인을 사용하는 것으로 추정됩니다. </p>
 
 <h3>개방 부호와 사용자 주도</h3>
 
 <p>와인은 언제나 <a href="https://wiki.winehq.org/Licensing"
-title="와인 저작권">무료 무른모</a>입니다. 거의 반절의 와인 원천 부호는 봉사자들이 작성했으며,
-그외에 자금 지원은 특히 와인 지원판을 판매하는 <a href="http://www.codeweavers.com/products/" title="CodeWeavers
-크로스오버 사무소">CodeWeavers</a>하고 있습니다.</p>
+title="와인 저작권">무료 무른모</a>입니다. 거의 반절의 와인 원시 부호는 봉사자들이 작성했으며,
+그외의 자금 지원은 특히 와인 지원판을 판매하는 <a href="http://www.codeweavers.com/products/" title="부호직조가
+넘나들기 사무소">부호직조가</a>에서 하고 있습니다.</p>
 
-<p>와인은 사용자 모임에 매우 의지합니다. 사용자들은 조언과 무른모 시험 결과를 <a href="//appdb.winehq.org/" title="와인 응용 무른모 정보기지">응용 무른모 정보기지</a>에 올리는대 시간을 할애하며, 저희<a href="//bugs.winehq.org/"
+<p>와인은 사용자 모임에 매우 의지합니다. 사용자들은 조언과 무른모 시험 결과를 <a href="//appdb.winehq.org/" title="와인 무른모 정보기지">무른모 정보기지</a>에 올리는데 시간을 할애하며, 저희<a href="//bugs.winehq.org/"
 title="버그질라">오류 추적기</a>로 개발자들에게 오류 보고서를 제출해주고, 
 <a href="//forums.winehq.org/" title="와인HQ 토론장">토론장</a>의 질문에 답해 줍니다.
 </p>
diff --git a/templates/ko/global/xml/trans/global.xml b/templates/ko/global/xml/trans/global.xml
index 89702b6d..c925ca78 100644
--- a/templates/ko/global/xml/trans/global.xml
+++ b/templates/ko/global/xml/trans/global.xml
@@ -4,7 +4,7 @@
     <!-- TOP TABS -->
     <str name="tab_winehq">와인HQ</str>
     <str name="tab_wiki">위키</str>
-    <str name="tab_appdb">응용 무른모 정보기지</str>
+    <str name="tab_appdb">무른모 정보기지</str>
     <str name="tab_bugs">버그질라</str>
     <str name="tab_forums">토론장</str>
 
@@ -13,6 +13,6 @@
 
     <!-- HOSTED BY LINK -->
     <str name="hosted_by">호스트 : </str>
-    <str name="hosted_by_alt">CodeWeavers - 윈도우용 응용 무른모를 리눅스와 맥에서</str>
+    <str name="hosted_by_alt">CodeWeavers - 윈도우용 무른모를 리눅스와 맥에서</str>
 
 </trans>
-- 
2.23.0.windows.1